#include "Defs.h"
#include "RPGApp.h"
#include "RPGWindow.h"


//--------------------------------------------------
//	Implementation of the RPGApp class
//--------------------------------------------------

// Constructor
RPGApp::RPGApp(const char *signature) : BApplication(signature){}


// Init the app and draw the window
void RPGApp::ReadyToRun()
{
	kUpperCase	=	true;
	kLowerCase	=	true;
	kNumbers	=	true;
	kDigitNb	=	8;
	kPasswordNb	=	1;
	
	BRect frame(WINDOW_X1, WINDOW_Y1, WINDOW_X2, WINDOW_Y2);
	RPGWindow *MyWindow = new RPGWindow(frame, "Random Password Generator");
	MyWindow->Show();
}


// Show the about box
void RPGApp::AboutRequested()
{
	Alert(	"Random Password Generator 1.3\n\nby Wilhem Meignan\nw.m@wanadoo.fr",
			"Cool", B_INFO_ALERT);
}


void RPGApp::Alert(char *alert_text, char *btn_text, alert_type type)
{
	BAlert *theAlert = new BAlert(	"Alert", alert_text, btn_text,
									NULL, NULL, B_WIDTH_AS_USUAL, type);
	theAlert->SetShortcut(0, B_ESCAPE);
	theAlert->Go();
	// Alert types are:
	// B_EMPTY_ALERT
	// B_INFO_ALERT
	// B_IDEA_ALERT
	// B_WARNING_ALERT
	// B_STOP_ALERT
}


// Generate the passwords and store them to a file
void RPGApp::GeneratePasswords()
{
	BPath path("/boot/home");
	path.Append("GenPasswords.txt");
	BFile outFile(path.Path(), B_WRITE_ONLY | B_CREATE_FILE | B_ERASE_FILE);
	if (outFile.InitCheck() != B_OK)
	{
		Alert("Could not create file !", "why me ?", B_STOP_ALERT);
		return;
	}
	
	char *password = new char[kDigitNb+1];
	
	for (int32 i=0; i < kPasswordNb; i++)
	{
		GenPassword(password, kDigitNb);
		outFile.Write(password, kDigitNb);
		outFile.Write("\n", 1);
	}
	
	delete [] password;
}


// Generate a password
void RPGApp::GenPassword(char *password, int digit_nb)
{
	BString symbols;
	if (kUpperCase)	symbols<<"ABCDEFGHIJKLMNOPQRTSUVWXYZ";
	if (kLowerCase)	symbols<<"abcdefghijklmnopqrstuvwxyz";
	if (kNumbers)	symbols<<"0123456789";
	
	int32 symb_nb = symbols.Length();
	
	int32 i;
	for (i=0; i < digit_nb; i++) password[i] = symbols.String()[rand()%symb_nb];
	password[i] = 0;	// terminate the string
}
