#include <Alert.h>
#include <Application.h>
#include <File.h>
#include <stdlib.h>
#include <StorageKit.h>
#include <String.h>
#include <unistd.h>


class RPGApp : public BApplication
{
public:
					RPGApp(const char *signature);
	
	virtual void	ReadyToRun();
	virtual void	AboutRequested();
	
	void			Alert(char *alert_text, char *btn_text, alert_type type);
	
	inline void		ChangeUpCase()		{kUpperCase = !kUpperCase;}
	inline void		ChangeLoCase()		{kLowerCase = !kLowerCase;}
	inline void		ChangeNumbers()		{kNumbers = !kNumbers;}
	
	inline bool		IsUpCase()			{return kUpperCase;}
	inline bool		IsLoCase()			{return kLowerCase;}
	inline bool		IsNumbers()			{return kNumbers;}
	
	inline void		SetDgNb(int32 nb)	{kDigitNb = nb;}
	inline void		SetPwNb(int32 nb)	{kPasswordNb = nb;}
	
	inline int32	DgNb()				{return kDigitNb;}
	inline int32	PwNb()				{return kPasswordNb;}
	
	void			GeneratePasswords();
	void			GenPassword(char *pass, int digit_nb);
	
	private:
	bool			kUpperCase;
	bool			kLowerCase;
	bool			kNumbers;
	
	int32			kDigitNb;
	int32			kPasswordNb;
};
